# $Header: /raid/cvsroot/DBIx/Handle/Handle.pm,v 1.13 2000/03/25 05:57:37 jesse Exp $
package DBIx::Handle;
use Carp;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;
require AutoLoader;

@ISA = qw(Exporter AutoLoader);
$VERSION = '0.02';


# Preloaded methods go here.


use DBI;

#instantiate a new object.
# {{{ sub new 
sub new  {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $self  = {};
  bless ($self, $class);
  #we have no limit statements. DoSearch won't work.
  return ($self)
}
# }}}

# {{{ sub Connect 
sub Connect  {
  my $self = shift;
  
  my %args = ( Driver => undef,
	       Database => undef,
	       Host => 'localhost',
	       User => undef,
	       Password => undef,
	       @_);
  
  my $dsn;
  
  $dsn = "dbi:$args{'Driver'}:$args{'Database'}:$args{'Host'}";
  
  $self->{'dbh'} = DBI->connect($dsn, $args{'User'}, $args{'Password'}) || croak "Connect Failed $DBI::errstr\n" ;


  $self->{'dbh'}->{RaiseError}=1;
  return ($self->{'dbh'}); 
}
# }}}


# {{{ sub Disconnect 
sub Disconnect  {
  my $self = shift;
  return ($self->{'dbh'}->disconnect());
}
# }}}
# {{{ sub Handle 
sub Handle  {
  my $self = shift;
  return($self->{'dbh'});
}
# }}}



# {{{ sub UpdateTableValue 
sub UpdateTableValue  {
  my $self = shift;
  
  my $Table = shift;
  my $Col = shift;
  my $NewValue = shift;
  my $Record = shift;
  my $QueryString;
  
  # quote the value
  $NewValue=$self->safe_quote($NewValue);
  # build the query string
  $QueryString = "UPDATE $Table SET $Col = $NewValue WHERE id = $Record";
  print STDERR $QueryString,"\n";
  
  # TODO update the last edited 
  

  my $sth = $self->{'dbh'}->prepare($QueryString);
  if (!$sth) {
    
    if ($main::debug) {
      die "Error:" . $self->{'dbh'}->errstr . "\n";
    }
    else {
      return (0);
      
    }
  }
  if (!$sth->execute) {
    if ($self->{'debug'}) {
      die "Error:" . $sth->errstr . "\n";
    }
    else {
      return(0);
    }
    
  }
  
  return (1); #Update Succeded
}
# }}}
 
 # {{{ sub safe_quote 
sub safe_quote  {
   my $self = shift;
   my $in_val = shift;
   my ($out_val);
   if (!$in_val) {
     return ("''");
     
   }
   else {
     $out_val = $self->{'dbh'}->quote($in_val);
     
   }
   return("$out_val");
   
}
# }}}
 
 
 
# Autoload methods go after =cut, and are processed by the autosplit program.
 
 1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

DBIx::Handle - Perl extension which is a generic DBI handle

=head1 SYNOPSIS

  use DBIx::Handle;

 my $Handle = DBIx::Handle->new();
 $Handle->Connect( Driver => 'mysql',
		   Database => 'dbname',
		   Host => 'hostname',
		   User => 'dbuser',
		   Password => 'dbpassword');
 
 

=head1 DESCRIPTION

Jesse's a slacker.

Blah blah blah.

=head1 AUTHOR

Jesse Vincent, jesse@fsck.com

=head1 SEE ALSO

perl(1), DBIx::EasySearch, DBIx::Record

=cut
